﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using DotSpatial.Controls;
using DotSpatial.Data;
using DotSpatial.Topology;

namespace DotSpatialView
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }

        private void frmMain_Load(object sender, EventArgs e)
        {
            mainMapLegend.AddMapFrame(mainMap.MapFrame);
        }

        private void toolStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            foreach (ToolStripButton item in ((ToolStrip)sender).Items) {
                if (item == sender) item.Checked = true;
                if ((item != null) && (item != sender))
                {
                    item.Checked = false;
                }
            }
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            if (mainMap.Layers.Count > 0)
            {
                MapPolygonLayer okresyLayer = (MapPolygonLayer)mainMap.Layers[0];
                if (okresyLayer == null)
                {
                    MessageBox.Show("Blba vrstva / potrebuji neco polygonoveho s atributem nazev");
                }
                else
                {
                    mainMap.AddLabels(okresyLayer, "[nazok]", new Font("Tahoma", 8), Color.Black);
                    dataGridView1.DataSource = okresyLayer.DataSet.DataTable;
                }
            }
            else
            {
                MessageBox.Show("Vloz vrstvu");
            }
        }

        private void toolStripButton7_Click(object sender, EventArgs e)
        {
            mainMap.FunctionMode = FunctionMode.Info;
        }

        private void toolStripButton6_Click(object sender, EventArgs e)
        {
            mainMap.FunctionMode = FunctionMode.Pan;
        }

        private void toolStripButton5_Click(object sender, EventArgs e)
        {
            mainMap.FunctionMode = FunctionMode.ZoomOut;
        }

        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            mainMap.FunctionMode = FunctionMode.ZoomIn;
        }

        private void dataGridView1_SelectionChanged(object sender, EventArgs e)
        {
            MapPolygonLayer okresyLayer = (MapPolygonLayer)mainMap.Layers[0];
            foreach (DataGridViewRow row in dataGridView1.SelectedRows)
            {
                okresyLayer.SelectByAttribute("[cat] = " + "'" + row.Cells["cat"].Value + "'", DotSpatial.Symbology.ModifySelectionMode.Append);
            }
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Opravdu ukončit?", "A", MessageBoxButtons.OKCancel) == DialogResult.OK) {
                this.Close();
            }
        }

        private void wPSClientToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmProcess fp = new frmProcess();
            fp.Show();
        }

        private void bufferToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmBuffer fb = new frmBuffer();
            fb.x = mainMap.Extent.Center.X;
            fb.y = mainMap.Extent.Center.Y;
            fb.ShowDialog();
            double size = fb.size;

            /*Buffer nad stredem mapy*/
            Feature ft = new Feature(mainMap.Extent.Center);
            FeatureSet newFs = new FeatureSet(FeatureType.Polygon);
            newFs.AddFeature(ft.Buffer(size));
            MapPolygonLayer bl = (MapPolygonLayer)mainMap.Layers.Add(newFs);
            bl.LegendText = "Buffer";
            mainMap.ResetBuffer();

            /*Buffer nad vybranymi polygony
             * MapPolygonLayer okresyLayer = (MapPolygonLayer)mainMap.Layers[0];
            FeatureSet newFs = new FeatureSet(FeatureType.Polygon);

            List<IFeature> fl = new List<IFeature>();
            fl = okresyLayer.Selection.ToFeatureList();
            String coordsstring = "";
            foreach (Feature f in fl) {
                newFs.AddFeature(f.Buffer(size));
                IList<Coordinate> coords =  f.Coordinates;
                foreach (Coordinate cor in coords) {
                    coordsstring = coordsstring + "; " + cor.X + ", " + cor.Y;
                }
                coordsstring = coordsstring + "\n";
            } */
            //this.Text += ls1[i].Fid.ToString()+" , "; //FID
            //this.Text += ls1[i].DataRow.ItemArray.GetValue(0).ToString() + " , "; //attribute 
            //MessageBox.Show(coordsstring);
  
        }
    }
}
