﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Xml;

namespace DotSpatialView
{
    public partial class frmProcess : Form
    {
        public frmProcess()
        {
            InitializeComponent();
        }

        private void btnCapabilities_Click(object sender, EventArgs e)
        {
            WebClient wc = new WebClient();
            try {
                String capabilites = wc.DownloadString("http://192.168.0.198:8080/geoserver/ows?service=wps&version=1.0.0&request=GetCapabilities");
                XmlDocument doc = new XmlDocument();
                doc.LoadXml(capabilites);
                XmlNamespaceManager nsmgr = new XmlNamespaceManager(doc.NameTable);
                nsmgr.AddNamespace("wps", "http://www.opengis.net/wps/1.0.0");
                nsmgr.AddNamespace("ows", "http://www.opengis.net/ows/1.1");
                XmlNodeList processes = doc.SelectNodes("//wps:Process", nsmgr);
                foreach (XmlNode process in processes)
                {
                    XmlNode identifier = process.SelectSingleNode("ows:Identifier", nsmgr);
                    cmbProcesses.Items.Add(identifier.InnerText);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message + " " + ex.StackTrace);
            }
        }

        private void frmProcess_Load(object sender, EventArgs e)
        {

        }

        private void cmbProcesses_SelectedIndexChanged(object sender, EventArgs e)
        {
            WebClient wc = new WebClient();
            try
            {
                String capabilites = wc.DownloadString("http://192.168.0.198:8080/geoserver/ows?service=wps&version=1.0.0&request=DescribeProcess&Identifier=" + cmbProcesses.SelectedItem.ToString());
                XmlDocument doc = new XmlDocument();
                doc.LoadXml(capabilites);
                XmlNamespaceManager nsmgr = new XmlNamespaceManager(doc.NameTable);
                nsmgr.AddNamespace("wps", "http://www.opengis.net/wps/1.0.0");
                nsmgr.AddNamespace("ows", "http://www.opengis.net/ows/1.1");
                XmlNodeList processes = doc.SelectNodes("//wps:Process", nsmgr);
                foreach (XmlNode process in processes)
                {
                    XmlNode identifier = process.SelectSingleNode("ows:Identifier", nsmgr);
                    cmbProcesses.Items.Add(identifier.InnerText);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message + " " + ex.StackTrace);
            }
        }
    }
}
